<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:xalan="http://xml.apache.org/xalan">


	<xsl:param name="java2html-root"/>

	<xsl:template name="system-link">
    <xsl:param name="path-to-root" select="''"/>
    <a target="classFrame">
	<xsl:attribute name="href"><xsl:call-template name="system-url">
                                    <xsl:with-param name="path-to-root" select="$path-to-root"/>
                                  </xsl:call-template></xsl:attribute>
	<xsl:value-of select="'Total System'"/>
	</a>
</xsl:template>

<xsl:template name="system-url">
    <xsl:param name="path-to-root" select="''"/><xsl:value-of select="$path-to-root"/>scorecard-overview.html</xsl:template>


<xsl:template name="subsystem-link">
	<xsl:param name="subsystem-name"/>
    <xsl:param name="path-to-root" select="''"/>
    <a target="classFrame">
	<xsl:attribute name="href"><xsl:call-template name="subsystem-url">
                                    <xsl:with-param name="subsystem-name" select="$subsystem-name"/>
                                    <xsl:with-param name="path-to-root" select="$path-to-root"/>
                                  </xsl:call-template></xsl:attribute>
	<xsl:value-of select="$subsystem-name"/>
	</a>
</xsl:template>

<xsl:template name="subsystem-url">
	<xsl:param name="subsystem-name"/>
	<xsl:param name="anchor" select="''"/>
    <xsl:param name="path-to-root" select="''"/><xsl:value-of select="$path-to-root"/>subsystems/overview-subsystem-<xsl:value-of select="normalize-space($subsystem-name)"/>.html<xsl:if test="$anchor != ''">#<xsl:value-of select="$anchor"/></xsl:if>
</xsl:template>

<xsl:template name="svg-subsystem-url">
	<xsl:param name="subsystem-name"/>
	<xsl:param name="anchor" select="''"/>
    <xsl:param name="path-to-root" select="''"/>
    <xsl:param name="log"/>
	<xsl:choose>
		<xsl:when test="$log = 'true'">
		    <xsl:message>
		    	Call to template "svg-subsystem-url" with param :
		    		<xsl:value-of select="$subsystem-name"/>
					<xsl:value-of select="anchor"/>
		    		<xsl:value-of select="$path-to-root"/>
		    		URL produced is:
		    		<xsl:value-of select="$path-to-root"/>subsystems/overview-subsystem-<xsl:value-of select="normalize-space($subsystem-name)"/>.html<xsl:if test="$anchor != ''">#<xsl:value-of select="$anchor"/></xsl:if>
		    </xsl:message>
		</xsl:when>
	</xsl:choose>
    <xsl:value-of select="$path-to-root"/>subsystems/overview-subsystem-<xsl:value-of select="normalize-space($subsystem-name)"/>.html<xsl:if test="$anchor != ''">#<xsl:value-of select="$anchor"/></xsl:if>
</xsl:template>

<xsl:template name="system-url-dynamics">
    <xsl:param name="path-to-root" select="''"/><xsl:value-of select="$path-to-root"/>topview-system.html</xsl:template>

<xsl:template name="subsystem-url-dynamics">
	<xsl:param name="subsystem-name"/>
    <xsl:param name="path-to-root" select="''"/><xsl:value-of select="$path-to-root"/>subsystems/topview-subsystem-<xsl:value-of select="normalize-space($subsystem-name)"/>.html</xsl:template>

<xsl:template name="package-url-dynamics">
    <xsl:param name="package-name"/>
    <xsl:param name="path-to-root" select="''"/><xsl:value-of select="$path-to-root"/>packages/topview-package-<xsl:value-of select="normalize-space($package-name)"/>.html</xsl:template>


<xsl:template name="package-link">
	<xsl:param name="package-name"/>
	<xsl:param name="path-to-root"/>
	<xsl:param name="link-name" select="$package-name"/>
    <a>
	<xsl:attribute name="href"><xsl:call-template name="package-url">
                                    <xsl:with-param name="package-name" select="$package-name"/>
                                    <xsl:with-param name="path-to-root" select="$path-to-root"/>
                                  </xsl:call-template></xsl:attribute>
	<xsl:value-of select="$link-name"/>
	</a>
</xsl:template>

<xsl:template name="package-url">
	<xsl:param name="package-name"/>
    <xsl:param name="path-to-root" select="''"/><xsl:value-of select="$path-to-root"/>packages/overview-package-<xsl:value-of select="$package-name"/>.html</xsl:template>

<xsl:template name="svg-package-url">
	<xsl:param name="package-name"/>
    <xsl:param name="path-to-root" select="''"/>
    <xsl:value-of select="$path-to-root"/>packages/overview-package-<xsl:value-of select="$package-name"/>.html</xsl:template>


<xsl:template name="package-javadoc-link">
      	<xsl:param name="link-name"/>
	<xsl:param name="package-name"/>
      	<xsl:param name="java-doc-root"/>
	<xsl:choose>
		<xsl:when test="$java-doc-root != ''">
			<a href="{$java-doc-root}/{translate($package-name,'.','/')}/package-summary.html" target="_new"><xsl:value-of select="$link-name"/></a>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$link-name"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="package-jcoverage-link">
      <xsl:param name="link-name"/>
	  <xsl:param name="package-name"/>
      <xsl:param name="jcoverage-root"/>
	  <a href="{$jcoverage-root}/{$package-name}.html" target="_new"><xsl:value-of select="$link-name"/></a>
</xsl:template>

<xsl:template name="package-cobertura-link">
      <xsl:param name="link-name"/>
	  <xsl:param name="package-name"/>
      <xsl:param name="cobertura-root"/>
	  <a href="{$cobertura-root}/frame-summary-{$package-name}.html" target="_new"><xsl:value-of select="$link-name"/></a>
</xsl:template>

<xsl:template name="package-emma-link">
      <xsl:param name="link-name"/>
	  <xsl:param name="package-name"/>
      <xsl:param name="emma-root"/>
	  <a href="{$emma-root}/index.html" target="_new"><xsl:value-of select="$link-name"/></a>
</xsl:template>

<xsl:template name="class-link">
	  <xsl:param name="class-name"/> <!-- Expects complete name with package -->
	  <xsl:param name="package-name"/>
	  <xsl:param name="link-name" select="substring-after($class-name, concat($package-name,'.'))"/>
	  <xsl:param name="path-to-root" select="''"/>
	  <a>
     <xsl:attribute name="href"><xsl:call-template name="class-url">
                                    <xsl:with-param name="class-name" select="$class-name"/>
                                    <xsl:with-param name="package-name" select="$package-name"/>
                                    <xsl:with-param name="path-to-root" select="$path-to-root"/>
                                  </xsl:call-template></xsl:attribute>
      <xsl:value-of select="$link-name"/>
      </a>
</xsl:template>

<xsl:template name="class-url">
	<xsl:param name="class-name"/>
	<xsl:param name="package-name"/>
    	<xsl:param name="path-to-root" select="'./'"/>
	<!--
	<xsl:message>
		class url making produced: <xsl:value-of select="$path-to-root"/>classes/<xsl:value-of select="$package-name"/>-classes.html#CL<xsl:value-of select="$class-name"/>
	</xsl:message>  -->
    	<xsl:value-of select="$path-to-root"/>classes/<xsl:value-of select="$package-name"/>-classes.html#CL<xsl:value-of select="$class-name"/>
</xsl:template>

<xsl:template name="class-xref-link">
      <xsl:param name="link-name"/>
      <xsl:param name="class-name"/>
      <xsl:param name="line-number" select="'1'"/>
	<!-- Links are relative to the file displaying them. In this case, we must move up... -->
	<xsl:variable name="path-to-classfile">
		<xsl:value-of select="concat('../',$java2html-root)"/>		
	</xsl:variable>
      <a target="_new" href="{$path-to-classfile}/{translate(normalize-space($class-name),'.','/')}.html#{$line-number}">
        <xsl:value-of select="$link-name"/>
      </a>
</xsl:template>

<xsl:template name="class-javadoc-link">
	<xsl:param name="link-name"/>
	<xsl:param name="class-name"/>
	<xsl:param name="java-doc-root"/>
	<xsl:param name="log" select="'true'"/>

	<xsl:choose>
		<xsl:when test="$java-doc-root != ''">
			<a target="_new" href="{$java-doc-root}/{translate($class-name,'.','/')}.html">
				<xsl:value-of select="$link-name"/>
      			</a>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$link-name"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="class-jcoverage-link">
      <xsl:param name="link-name"/>
	  <xsl:param name="class-name"/>
      <xsl:param name="jcoverage-root"/>
	  <a href="{$jcoverage-root}/{$class-name}.html" target="_new"><xsl:value-of select="$link-name"/></a>
</xsl:template>

<xsl:template name="class-cobertura-link">
      <xsl:param name="link-name"/>
	  <xsl:param name="class-name"/>
      <xsl:param name="cobertura-root"/>
	  <a href="{$cobertura-root}/{$class-name}.html" target="_new"><xsl:value-of select="$link-name"/></a>
</xsl:template>


<xsl:template name="class-emma-link">
      <xsl:param name="link-name"/>
	  <xsl:param name="class-name"/>
      <xsl:param name="emma-root"/>
	  <a href="{$emma-root}/{$class-name}.html" target="_new"><xsl:value-of select="$link-name"/></a>
</xsl:template>

</xsl:stylesheet>
