<?xml version="1.0" encoding="UTF-8"?>
<!-- =======================================================================
XRadar
Copyright (c) 2004, 2005, Kristoffer Kvam
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of Kristoffer Kvam nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

See licence.txt for dependancies to other open projects.
======================================================================= -->
<xsl:stylesheet
	version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:redirect="http://xml.apache.org/xalan/redirect"
	extension-element-prefixes="redirect">
	<xsl:template match="Package" mode="classes-details">
		<xsl:param name="path-to-root" select="'../'"/>
		<html>
			<head>
				<link rel="stylesheet" type="text/css"
					href="../stylesheet.css"/>
<script type="text/javascript" LANGUAGE="JavaScript">
function winpopanalysisdetails(loc){
Hwnd=window.open(loc,"Radar",'height=750,width=750,top=25,left=75,toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=yes,resizable=1');
if (Hwnd.focus != null) Hwnd.focus();
}
</script>
			</head>
			<body>
				<xsl:call-template name="page-header">
					<xsl:with-param name="main-menu-page-name"
						select="'scorecard'"/>
					<xsl:with-param name="page-name"
						select="concat('classes-', @name)"/>
					<xsl:with-param name="path-to-root" select="'../'"/>
					<xsl:with-param name="package-name" select="@name"/>
				</xsl:call-template>
				<xsl:if test="count(error) = 0">
					<xsl:apply-templates select = "AbstractClasses/Class"
						mode="classes-details">
						<xsl:with-param name="path-to-root"
							select="$path-to-root"/>
					</xsl:apply-templates>
					<xsl:apply-templates select = "ConcreteClasses/Class"
						mode="classes-details">
						<xsl:with-param name="path-to-root"
							select="$path-to-root"/>
					</xsl:apply-templates>
				</xsl:if>
			</body>
		</html>
	</xsl:template>
	<xsl:template match="Class" mode="classes-details">
		<xsl:param name="path-to-root" select="'../'"/>
		<xsl:variable name="class-name" select="normalize-space(node())"/>
		<h3>
			<a>
				<xsl:attribute name="name">CL<xsl:value-of
					select="normalize-space(node())"/></xsl:attribute>
				<xsl:value-of select="$class-name"/>
			</a>
		</h3>
		<table width="100%">
			<tr>
				<td><b>Package: <a><xsl:attribute
					name="href"><xsl:call-template name="package-url">
					<xsl:with-param name="package-name" select="../../@name"/>
					<xsl:with-param name="path-to-root"
					select="$path-to-root"/>
					</xsl:call-template></xsl:attribute> <xsl:value-of
					select="normalize-space(../../@name)"/></a></b> | <b>
					<xsl:call-template name="class-xref-link"> <xsl:with-param
					name="link-name" select="'Class source'"/> <xsl:with-param
					name="class-name" select="$class-name"/> <xsl:with-param
					name="java2html-root" select="$java2html-root"/> </xsl:call-template>
					</b> <xsl:if test="$java-doc-configured = 'true'"> | <b>
					<xsl:call-template name="class-javadoc-link">
					<xsl:with-param name="link-name" select="'Class javadoc'"/>
					<xsl:with-param name="class-name" select="$class-name"/>
					<xsl:with-param name="java-doc-root"
					select="$java-doc-root"/> </xsl:call-template></b>
					</xsl:if> <xsl:if test="$jcoverage-configured = 'true'"> |
					<b> <xsl:call-template name="class-jcoverage-link">
					<xsl:with-param name="link-name"
					select="'Class coverage details'"/> <xsl:with-param
					name="class-name" select="$class-name"/> <xsl:with-param
					name="jcoverage-root" select="$jcoverage-root"/>
					</xsl:call-template></b> </xsl:if> <xsl:if
					test="$cobertura-configured = 'true'"> | <b>
					<xsl:call-template name="class-cobertura-link">
					<xsl:with-param name="link-name"
					select="'Class coverage details'"/> <xsl:with-param
					name="class-name" select="$class-name"/> <xsl:with-param
					name="cobertura-root" select="$cobertura-root"/>
                                        </xsl:call-template></b> </xsl:if>
                                        <xsl:if test="$emma-configured = 'true'"> | <b>
                                                        <xsl:call-template
                                                                name="class-emma-link">
                                                                <xsl:with-param name="link-name"
                                                                        select="'Class coverage details'" />
                                                                <xsl:with-param name="class-name"
                                                                        select="$class-name" />
                                                                <xsl:with-param name="emma-root"
                                                                        select="$emma-root" />
                                                        </xsl:call-template>
                                                </b>
                                        </xsl:if>
                                        </td>
			</tr>
		</table>
		<br/>
		<table width="100%" class="details">
			<tr>
				<th colspan="2">Methods:</th>
				<th colspan="2">Source statements:</th>
				<th colspan="2">Cyclomatic Complexity</th>
			</tr>
			<tr>
				<td valign="top">
					Total:<br/>
					Total Declared:<br/>
					Public :<br/>
					Private :<br/>
				</td>
				<td valign="top">
					<xsl:value-of select="oo-metrics/wmc"/><br/>
					<xsl:value-of select="standard-metrics/functions"/><br/>
					<xsl:value-of select="oo-metrics/npm"/><br/>
					<xsl:value-of select="oo-metrics/wmc - oo-metrics/npm"/><br/>
				</td>
				<td valign="top"> Total :<br/> Per method :<br/> </td>
				<td valign="top">
					<xsl:value-of select="standard-metrics/ncss"/>
					<br/>
					<xsl:value-of
						select="format-number(standard-metrics/ncss div standard-metrics/functions,'#.##')"/>
				</td>
				<td valign="top"> Total :<br/> Per method :<br/> Per statement
					:<br/> </td>
				<td valign="top">
					<xsl:value-of select="standard-metrics/ccn"/>
					<br/>
					<xsl:value-of
						select="format-number(standard-metrics/ccn div standard-metrics/functions, '#.##')"/>
					<br/>
					<xsl:value-of
						select="format-number(standard-metrics/ccn div standard-metrics/ncss, '#.##')"/>
					<br/>
				</td>
			</tr>
			<tr>
				<th colspan="2">Inheritance:</th>
				<th colspan="2">Coupling:</th>
				<xsl:if test="coupling-metrics">
				<th colspan="2">Efferent (Import) Couplings:</th>
				<th colspan="2">Afferent (Export) Couplings:</th>
				</xsl:if>
			</tr>
			<tr>
				<td valign="top">Depth of inheritance tree (DIT):<br/> Number of Children (NOC):<br/></td>
				<td valign="top">
					<xsl:value-of select="oo-metrics/dit"/> <br/>
					<xsl:value-of select="oo-metrics/noc"/><br/>
				</td>
				<td valign="top">
					Efferent/Import Class Couplings (CBO/Ce):<br/>
					Afferent/Export Class Couplings (Ca):<br/>
					Response for a class (RFC):<br/>
					Lack of Cohesion in methods (LCOM):<br/>
				</td>
				<td valign="top">
					<xsl:value-of select="oo-metrics/cbo"/> <br/>
					<xsl:value-of select="oo-metrics/ca"/><br/>
					<xsl:value-of select="oo-metrics/rfc"/><br/>
					<xsl:value-of select="oo-metrics/lcom"/><br/>
				</td>
				<xsl:if test="coupling-metrics">
				<td valign="top">Class Internal:<br/>Package Internal :<br/>Subsystem Internal :<br/>System Internal :<br/> External:<br/>Java Library :<br/></td>
				<td valign="top">
					<xsl:value-of select="coupling-metrics/class-internal-imports"/><br/>
					<xsl:value-of select="coupling-metrics/package-internal-imports - coupling-metrics/class-internal-imports"/><br/>
					<xsl:value-of select="coupling-metrics/subsystem-internal-imports - coupling-metrics/package-internal-imports"/><br/>
					<xsl:value-of select="coupling-metrics/system-internal-imports - coupling-metrics/subsystem-internal-imports"/><br/>
					<xsl:value-of select="coupling-metrics/external-imports - coupling-metrics/runtime-library-imports"/><br/>
					<xsl:value-of select="coupling-metrics/runtime-library-imports"/><br/>
				</td>
				<td valign="top">Class Internal:<br/>Package Internal :<br/>Subsystem Internal :<br/>System Internal :<br/></td>
				<td valign="top">
					<xsl:value-of select="coupling-metrics/class-internal-exports"/><br/>
					<xsl:value-of select="coupling-metrics/package-internal-exports - coupling-metrics/class-internal-exports"/><br/>
					<xsl:value-of select="coupling-metrics/subsystem-internal-exports - coupling-metrics/package-internal-exports"/><br/>
					<xsl:value-of select="coupling-metrics/system-internal-exports - coupling-metrics/subsystem-internal-exports"/><br/>
				</td>
				</xsl:if>
			</tr>

			<tr>
				<th colspan="2">Javadocs:</th>
				<th colspan="2">Code violations:</th>
				<th colspan="2">Style Errors:</th>
				<xsl:if test="test-metrics">
					<th colspan="2">Unit Test Coverage</th>
				</xsl:if>
				<xsl:if test="source-control-metrics">
					<th colspan="2">Source Control</th>
				</xsl:if>
			</tr>
			<tr>
				<td valign="top"> Total :<br/> Per method :<br/> </td>
				<td valign="top">
					<xsl:value-of select="standard-metrics/javadocs"/>
					<br/>
					<xsl:value-of
						select="format-number(standard-metrics/javadocs div standard-metrics/functions, '#.##')"/>
					<br/>
				</td>
				<td valign="top"> Total :<br/> Per method :<br/> Per statement
					:<br/> </td>
				<td valign="top">
					<xsl:value-of select="violations/@total-number"/>
					<br/>
					<xsl:value-of
						select="format-number(violations/@total-number div standard-metrics/functions, '#.##')"/>
					<br/>
					<xsl:value-of
						select="format-number(violations/@total-number div standard-metrics/ncss, '#.##')"/>
					<br/>
				</td>
				<td valign="top"> Total :<br/> Per method :<br/> Per statement
					:<br/> </td>
				<td valign="top">
					<xsl:value-of select="style-errors/@total-number"/>
					<br/>
					<xsl:value-of
						select="format-number(style-errors/@total-number div standard-metrics/functions, '#.##')"/>
					<br/>
					<xsl:value-of
						select="format-number(style-errors/@total-number div standard-metrics/ncss, '#.##')"/>
					<br/>
				</td>
				<xsl:if test="test-metrics">
					<td valign="top">Statement Test Coverage :<br/>Method Test Reference :<br/> </td>
					<td valign="top"> <xsl:value-of
						select="format-number(sum(test-metrics/line-coverage),'#.##')"/><br/>
						<xsl:value-of
							select="format-number(sum(test-metrics/methods-referenced) div sum(oo-metrics/npm), '#.##')"/><br/>
					</td>

				</xsl:if>
				<xsl:if test="source-control-metrics">
					<td valign="top"> Changes :<br/> Errors :<br/> </td>
					<td valign="top">
						<xsl:value-of
							select="source-control-metrics/change-activity"/>
						<br/>
						<xsl:value-of
							select="source-control-metrics/error-activity"/>
						<br/>
					</td>
				</xsl:if>
			</tr>
		</table>
		<br/>
		<xsl:if test="fields">
		<table width="100%" class="details">
			<tr>
				<th>Field</th>
				<th>Type</th>
				<th>Import Couplings:</th>
				<th>Export Couplings:</th>
				<th>Illegal Import Couplings:</th>
				<th>Illegal Export Couplings:</th>
			</tr>
			<xsl:for-each select="fields/field">
				<tr>
					<td width="20%">
						<xsl:value-of select="substring-after(name, concat(normalize-space(../../node()),'.'))"/><br/>
					</td>
					<td>
						<xsl:value-of select="type"/>
					</td>
					<td>
						<xsl:value-of
							select="count(coupling/import)"/>
					</td>
					<td>
						<xsl:value-of
							select="count(coupling/export)"/>
					</td>
					<td>
						<xsl:if test="count(coupling/import[not(@legal='true')]) &gt; 0">
							<xsl:attribute name="style">background-color: Orange;</xsl:attribute>
						</xsl:if>
						<xsl:value-of
							select="count(coupling/import[not(@legal='true')])"/>
					</td>
					<td>
						<xsl:if test="count(coupling/export[not(@legal='true')]) &gt; 0">
							<xsl:attribute name="style">background-color: Orange;</xsl:attribute>
						</xsl:if>
						<xsl:value-of
							select="count(coupling/export[not(@legal='true')])"/>
					</td>
				</tr>
			</xsl:for-each>
		</table>
		</xsl:if>
		<br/>
		<table width="100%" class="details">
			<xsl:variable name="test-couplings" select="count(functions/function/test-coupling)"/>
			<xsl:variable name="test-coverages" select="count(functions/function/test-metrics/line-coverage)"/>
			<tr>
				<th>Method <xsl:if test="coupling-metrics">(View coupling details)</xsl:if>:</th>
				<th>Javadocs:</th>
				<th>Source statements:</th>
				<th>Cyclometic complexity:</th>
				<xsl:if test="functions/function/coupling-metrics">
					<th>Import Couplings:</th>
					<th>Export Couplings:</th>
					<th>Illegal Import Couplings:</th>
					<th>Illegal Export Couplings:</th>
				</xsl:if>
				<xsl:if test="$test-couplings &gt; 0">
					<th>Test References:</th>
				</xsl:if>
				<xsl:if test="$test-coverages &gt; 0">
					<th>Test Coverage:</th>
				</xsl:if>
			</tr>
			<xsl:for-each select="functions/function">
				<tr>
					<td width="40%">
						<xsl:choose>
						<xsl:when test="coupling-metrics">
                            <xsl:variable name="filename" select="concat('../',concat('methods/', substring-before(name, '('), '_', position(), '.html'))"/>
                            <a href="javascript:winpopanalysisdetails('{$filename}')">
							<xsl:value-of select="substring-after(name, concat(normalize-space(../../node()),'.'))"/></a>
						</xsl:when>
						<xsl:otherwise><xsl:value-of select="substring-after(name, concat(normalize-space(../../node()),'.'))"/></xsl:otherwise>
						</xsl:choose><br/>
					</td>
					<td width="10%">
						<xsl:value-of select="javadocs"/>
					</td>
					<td width="10%">
						<xsl:value-of select="ncss"/>
					</td>
					<td width="10%">
						<xsl:value-of select="ccn"/>
					</td>
					<xsl:if test="coupling-metrics">
						<td width="10%">
							<xsl:value-of
								select="coupling-metrics/import-coupling"/>
						</td>
						<td width="10%">
							<xsl:value-of
								select="coupling-metrics/export-coupling"/>
						</td>
						<td width="10%">
							<xsl:if test="count(coupling/import[not(@legal='true')]) &gt; 0">
								<xsl:attribute name="style">background-color: Orange;</xsl:attribute>
							</xsl:if>
							<xsl:value-of
								select="count(coupling/import[not(@legal='true')])"/>
						</td>
						<td width="10%">
							<xsl:if test="count(coupling/export[not(@legal='true')]) &gt; 0">
								<xsl:attribute name="style">background-color: Orange;</xsl:attribute>
							</xsl:if>
							<xsl:value-of
								select="count(coupling/export[not(@legal='true')])"/>
						</td>
					</xsl:if>
					<xsl:if test="$test-couplings &gt; 0">
						<td width="10%">
							<xsl:value-of
								select="count(test-coupling/export)"/>
						</td>
					</xsl:if>
					<xsl:if test="$test-coverages &gt; 0">
						<td width="10%">
							<xsl:choose>
								<xsl:when test="test-metrics/line-coverage">
									<xsl:value-of
										select="format-number(test-metrics/line-coverage, '#.##')"/>
								</xsl:when>
								<xsl:otherwise>0</xsl:otherwise>
							</xsl:choose>
						</td>
					</xsl:if>
				</tr>
			</xsl:for-each>
		</table>
		<br/>
		<xsl:if test="duplications/duplication">
			<table width="100%" class="details">
				<tr>
					<th>View line in source of duplicated classes</th>
					<th>Lines</th>
					<th>Tokens</th>
					<th>Start of code fragment</th>
				</tr>
				<xsl:for-each select="duplications/duplication">
					<tr>
						<td valign="top" width="30%">
							<xsl:for-each select="classref">
								<xsl:call-template name="class-xref-link">
									<xsl:with-param
										name="link-name"
										select="concat('(',@line,')',' ',@name)"/>
									<xsl:with-param
										name="class-name"
										select="@name"/>
									<xsl:with-param
										name="java2html-root"
 										select="$java2html-root"/>
									<xsl:with-param
										name="line-number"
										select="@line"/>
								</xsl:call-template>
								<br/>
							</xsl:for-each>
						</td>
						<td valign="top" width="10%">
							<xsl:value-of select="lines"/>
						</td>
						<td valign="top" width="10%">
							<xsl:value-of select="tokens"/>
						</td>
						<td valign="top" width="50%"> <xsl:value-of
							select="start-fragment"/> .....<br/> </td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:if>
		<br/>
		<xsl:if test="violations/violation">
			<table width="100%" class="details">
				<tr>
					<th>View line in source</th>
					<th>Code Violation</th>
					<th>Rule</th>
				</tr>
				<xsl:for-each select="violations/violation">
					<tr>
						<td valign="top" width="20%">
							<xsl:call-template name="class-xref-link">
								<xsl:with-param name="link-name"
									select="@line"/>
								<xsl:with-param name="class-name"
									select="$class-name"/>
								<xsl:with-param name="java2html-root"
 									select="$java2html-root"/>
								<xsl:with-param name="line-number"
									select="@line"/>
							</xsl:call-template>
						</td>
						<td valign="top" width="60%">
							<xsl:value-of select="."/>
						</td>
						<td valign="top" width="20%">
							<xsl:value-of select="@rule"/>
						</td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:if>
		<br/>
		
		
		
		<!-- David Stokar -->
 		<br/>
 		<xsl:if test="BugInstance">
 			<table width="100%" class="details">
 				<tr>
 					<th>Bug: Category</th>
 					<th>Type</th>
 					<th>Abbreviation</th>
 					<th>Priority</th>
 					<th>Method Name</th>
 					<th>Field Name</th>
 				</tr>
 				<xsl:for-each select="BugInstance">
 					<tr>
 						<td valign="top" width="60%">
 							<xsl:value-of select="@category"/>
 						</td>
 						<td valign="top" width="60%">
 							<xsl:value-of select="@type"/>
 						</td>
 						<td valign="top" width="60%">
 							<xsl:value-of select="@abbrev"/>
 						</td>
 						<td valign="top" width="60%">
 							<xsl:value-of select="@priority"/>
 						</td>
 						<td valign="top" width="60%">
 							<xsl:value-of select="Method/@name"/>
 						</td>
 						<td valign="top" width="60%">
 							<xsl:value-of select="Field/@name"/>
 						</td>
 
 					</tr>
 				</xsl:for-each>
 			</table>
 		</xsl:if>
 <!-- End David Stokar -->
		
		<xsl:if test="style-errors/error">
			<table width="100%" class="details">
				<tr>
					<th>View line in source</th>
					<th>Style Error</th>
					<th>Column</th>
				</tr>
				<xsl:for-each select="style-errors/error">
					<tr>
						<td valign="top" width="20%">
							<xsl:call-template name="class-xref-link">
								<xsl:with-param name="link-name"
									select="@line"/>
								<xsl:with-param name="class-name"
									select="$class-name"/>
								<xsl:with-param name="path-to-root"
									select="'../'"/>
								<xsl:with-param name="line-number"
									select="@line"/>
							</xsl:call-template>
						</td>
						<td valign="top" width="60%">
							<xsl:value-of select="@message"/>
						</td>
						<td valign="top" width="20%">
							<xsl:value-of select="@column"/>
						</td>
					</tr>
				</xsl:for-each>
			</table>
		</xsl:if>
		<xsl:if test="coupling-metrics">
			<xsl:for-each select="functions/function">
                <xsl:variable name="filename" select="concat($docs-home,concat('methods/', substring-before(name, '('), '_', position(), '.html'))"/>
                <redirect:write file="{$filename}">
				<html>
      			<head>
					 <link rel="stylesheet" type="text/css" href="../stylesheet.css"/>
				</head>
				<body>
				Method: <xsl:value-of select="name"/>
				<br/>
				<table width="100%" class="details">
					<tr>
						<th>Imports</th>
						<th>Class Internal</th>
						<th>Package Internal</th>
						<th>Subsystem Internal</th>
						<th>System Internal</th>
						<th>External</th>
						<th>Java Library</th>
						<th>Illegal Import</th>
					</tr>
					<xsl:for-each select="coupling/import">
						<xsl:sort select="@system-internal" order="descending"/>
						<xsl:apply-templates select="current()" mode="method-coupling"/>
					</xsl:for-each>

					<tr>
						<th>Exports</th>
						<th>Class Internal</th>
						<th>Package Internal</th>
						<th>Subsystem Internal</th>
						<th>System Internal</th>
						<th>External</th>
						<th>Java Library</th>
						<th>Illegal Export</th>
					</tr>
					<xsl:for-each select="coupling/export">
						<xsl:sort select="@external" order="descending"/>
						<xsl:apply-templates select="current()" mode="method-coupling"/>
					</xsl:for-each>

					<xsl:if test="test-coupling">
					<tr>
						<th>Test Exports</th>
						<th>Class Internal</th>
						<th>Package Internal</th>
						<th>Subsystem Internal</th>
						<th>System Internal</th>
						<th>External</th>
						<th>Java Library</th>
						<th>Illegal Export</th>
					</tr>
					<xsl:for-each select="test-coupling/export">
						<xsl:sort select="@external" order="descending"/>
						<xsl:apply-templates select="current()" mode="method-coupling"/>
					</xsl:for-each>
					</xsl:if>
				</table>
				</body>
				</html>
				</redirect:write>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>

<xsl:template match="export|import" mode="method-coupling">
	<tr>
		<td valign="top">
			<xsl:value-of select="node()"/>
		</td>
		<td valign="top">
			<xsl:if test="@class-internal='true'">
				X
			</xsl:if>
		</td>
		<td valign="top">
			<xsl:if test="not(@class-internal='true') and @package-internal='true'">
				X
			</xsl:if>
		</td>
		<td valign="top">
			<xsl:if test="not(@class-internal='true') and not(@package-internal='true') and @subsystem-internal='true'">
				X
			</xsl:if>
		</td>
		<td valign="top">
			<xsl:if test="not(@class-internal='true') and not(@package-internal='true') and not(@subsystem-internal='true') and @system-internal='true'">
				X
			</xsl:if>
		</td>
		<td valign="top">
			<xsl:if test="not(@system-internal='true') and not(@runtime-library='true')">
				X
			</xsl:if>
		</td>
		<td valign="top">
			<xsl:if test="@runtime-library='true'">
				X
			</xsl:if>
		</td>
		<td valign="top">
			<xsl:if test="not(@legal='true')">
				<xsl:attribute name="style">background-color: Orange;</xsl:attribute>
				X
			</xsl:if>
		</td>
	</tr>
</xsl:template>
</xsl:stylesheet>
